#include "Eigen/Dense"
#include <cassert>
#include <iostream>

int main(int c, char* v[]) {
  assert(c==2);
  int n=std::stoi(v[1]);
  using T=float;
  // using T=double;
  typedef Eigen::Matrix<T,Eigen::Dynamic,Eigen::Dynamic> MT;
  typedef Eigen::Matrix<T,Eigen::Dynamic,1> VT;
  MT A=MT::Random(n,n), B=MT::Random(n,n);
  VT C=VT::Random(n);
  // MT D=A*B*C; // =(A*B)*C ... Cost=O(n*n*n)
  MT D=A*(B*C); // Cost=O(n*n)
  // std::cout.precision(7);
  std::cout.precision(15);
  std::cout << D << std::endl;
  return 0;
}

